import { EVMContractAddress, TokenUri, SiftContractError, BaseURI, DomainName, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { IEthersContractError } from "../implementations/BlockchainErrorMapper.js";
import { WrappedTransactionResponse } from "../interfaces/index.js";
import { ISiftContract } from "../interfaces/ISiftContract.js";
import { ContractOverrides } from "../interfaces/objects/ContractOverrides.js";
export declare class SiftContract extends BaseContract<SiftContractError> implements ISiftContract {
    protected providerOrSigner: ethers.Provider | ethers.Signer;
    protected contractAddress: EVMContractAddress;
    constructor(providerOrSigner: ethers.Provider | ethers.Signer, contractAddress: EVMContractAddress);
    getContractAddress(): EVMContractAddress;
    checkURL(domain: DomainName): ResultAsync<TokenUri, SiftContractError | BlockchainCommonErrors>;
    verifyURL(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | SiftContractError>;
    maliciousURL(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | SiftContractError>;
    setBaseURI(baseUri: BaseURI, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | SiftContractError>;
    protected generateContractSpecificError(msg: string, e: IEthersContractError, transaction: ethers.Transaction | null): SiftContractError;
}
//# sourceMappingURL=SiftContract.d.ts.map