var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { EVMContractAddress, SiftContractError, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { ContractsAbis } from "../interfaces/objects/index.js";
let SiftContract = class SiftContract extends BaseContract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, ContractsAbis.SiftAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    getContractAddress() {
        return this.contractAddress;
    }
    checkURL(domain) {
        // Returns the tokenURI or string
        // eg. 'www.sift.com/VERIFIED', 'www.sift.com/MALICIOUS' or 'NOT VERIFIED'
        return ResultAsync.fromPromise(this.contract.checkURL(domain), (e) => {
            return this.generateError(e, `Unable to call checkURL(${domain})`);
        });
    }
    // Sets a domain as VERIFIED
    verifyURL(domain, overrides) {
        return this.writeToContract("verifyURL", [domain], overrides);
    }
    // Sets a domain as MALICIOUS
    maliciousURL(domain, overrides) {
        return this.writeToContract("maliciousURL", [domain], overrides);
    }
    setBaseURI(baseUri, overrides) {
        return this.writeToContract("setBaseURI", [baseUri], overrides);
    }
    generateContractSpecificError(msg, e, transaction) {
        return new SiftContractError(msg, e, transaction);
    }
};
SiftContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object, String])
], SiftContract);
export { SiftContract };
//# sourceMappingURL=SiftContract.js.map